<?php
/**
* @copyright Copyright (C) 2008-2010 Pixel Praise LLC. All rights reserved.
*/
// no direct access
// Deny direct access to the file - VERY IMPORTANT!
defined( '_JEXEC' ) or die( 'Restricted access' );

$com  = PFcomponent::GetInstance();
$load = PFload::GetInstance();
$cfg  = PFconfig::GetInstance();
$core = PFcore::GetInstance();

$location = $com->Get('location');
$hide_tpl = $cfg->Get('hide_template');
$section  = $core->GetSection();
$task  = $core->GetTask();

$uri  = JFactory::getURI();

// Load theme header processes
PFprocess::Event('theme_header');

// Hide Logo Header Area
$hide_logo = $cfg->get('hide_logo', 'theme_carbon');

// Hide Task Info
$hide_info = $cfg->get('hide_info', 'theme_carbon');

// Hide Return Link
$hide_return = $cfg->get('hide_return', 'theme_carbon');

// Hide Footer
$hide_footer = $cfg->get('hide_footer', 'theme_carbon');

// Load theme CSS
$load->ThemeCSS('general.css');
$load->ThemeCSS('theme.css');
$load->ThemeCSS('icons.css');
?>
<!--[if IE 7]>
<style type="text/css">
#theme_top{
float:none;
}
.milestone .pf_edit a,.pf_inline_menu .pf_edit a{
width:30px;
}
.pf_milestone_title .pf_new a,.pf_inline_menu .pf_complete a,
.pf_inline_menu .pf_timeadd a{
width:60px;
}
.pf_inline_menu .pf_comments a{
width:70px;
}
</style>
<![endif]-->
<?php
// Hide the joomla admin toolbar in the backend, we're not using it
if($location == 'backend') {
    echo '<style type="text/css">#toolbar-box { display:none; }</style>';
}

// Load theme for location
if($location == 'frontend' && $hide_tpl == '1') {
	$load->ThemeCSS('notpl.css');
} else if($location == 'frontend' && !$hide_tpl) {
	$load->ThemeCSS('frontend.css');
} else if($location == 'backend') {
	$load->ThemeCSS('backend.css');
}

//Check for active workspace
$user = PFuser::GetInstance();
$workspace = $user->GetWorkspace();

//Change the active Joomla template if using Projectfork on the frontend and hiding Joomla
$user = &JFactory::getUser();
if($location == 'frontend' && $hide_tpl == '1') {
$app =& JFactory::getApplication();
$app->setTemplate('rhuk_milkyway'); 
}
?>

<?php if(($location == "frontend") && ($hide_tpl)){?>
<link media="only screen and (max-device-width: 480px)" href="<?php echo JURI::root();?>/administrator/components/com_projectfork/themes/carbon/css/iphone.css" type="text/css" rel="stylesheet" />
<link rel="apple-touch-icon" href="<?php echo JURI::root();?>/administrator/components/com_projectfork/themes/carbon/images/apple-touch-icon.png" />
<div class="frontend_notemplate">
<?php } ?>
<div class="pf_hide_sidebar">

<div id="theme_wrapper" class="pf_<?php echo $location . " pfsec_" . $section . " pftask_" . $task;?> pf_project <?php if($hide_info){echo"pf-hideinfo";}?>">
    <div id="theme_info">
    	<?php PFpanel::Position("theme_info"); ?>
    </div>
    
    <div class="clr"></div>


  <div id="theme_top">
    <div id="theme_mainpanel">
    	<?php if($location == 'frontend' && $hide_tpl == '1' && !$hide_return) { ?>
    		<ul class="return-list">
    		<li class="return-item"><a href="<?php echo $uri->base();?>index.php" class="pf-return-link"><span>Return to site</span></a></li>
    		</ul>
    	<?php } ?>
    	<?php PFpanel::Position("theme_header"); ?>
    </div>
  </div>
  <div id="theme_body">
  	<div id="theme_inner">
  		<?php if(!$hide_logo){ ?>
  		<div id="theme_misc">
  		
  			<div id="pf_panel_theme_logo">
  				<?php echo PFpanel::Render("theme_logo", "none"); ?>
  			</div>
  			<div id="pf_panel_quicklink_project">
  				<?php echo PFpanel::Render("quicklink_project", "none"); ?>
  			</div>
  			<?php if($user){?>
  			<div id="pf_panel_welcome">
  				<?php echo PFpanel::Render("cp_welcome", "none"); ?>
  			</div>
  			<?php } ?>
  			<div class="clr"></div>
  		
  		</div>
  		<?php } ?>
         <div id="<?php echo $section;?>_content" class="theme_content">
            <div id="theme_maintop"><?php PFpanel::Position('theme_pos1'); ?><?php PFpanel::Position("theme_top"); ?></div>
            <div id="theme_main"><?php PFsection::Render(); ?></div>
            <div id="theme_bottom"><?php PFpanel::Position("theme_bottom"); ?></div>
         </div>
         <div class="clr"></div>
     </div>
  </div>
  <div class="clr"></div>
  <?php if(!$hide_footer){ ?>
  <div class="theme_footer"> 
    Official <a target="_blank" href="http://www.projectfork.net/" class="pf-footlogo">Projectfork</a>
     <a target="_blank" href="http://www.projectfork.net/projectfork/themes.php">Themes</a>
    &amp; <a target="_blank" href="http://www.projectfork.net/projectfork/extensions.php">Extensions</a>
    <div class="clr"></div>
    <?php PFpanel::Position("theme_footer"); ?>
  </div>
  <?php } ?>
  <div class="clr"></div>
  <?php if(!$cfg->get('hide_time', 'theme_carbon')){ ?>
  <div id="theme_time">
       		<?php echo PFpanel::Render("time_tracking"); ?>
  </div>
  <?php } ?>
</div>


</div>
<?php if(($location == "frontend") && ($hide_tpl)){?>
</div>
<?php } ?>

<div id="theme_footer">
	<?php PFpanel::Position("theme_debug"); ?>
</div>
<div id="hiddenDiv">
	<div id="theme_pos2">
		<?php PFpanel::Position('theme_pos2'); ?>
	</div>
</div>
<script type='text/javascript'>
	window.addEvent('domready',function() {
	        var div = $('hiddenDiv').setStyles({
	                display:'block',
	                opacity: 1
	        }); 
	        
	        new Fx.Style('hiddenDiv', 'opacity', {duration:2000, onComplete:
			function() {
	        	new Fx.Style('hiddenDiv', 'opacity', {duration:2000}).start(0);
	        }}).start(1);
	}); 
</script>